/*
	main.c
*/

#include <gtk/gtk.h>
#include <stdio.h>
#include "config.h"
#include "graph.h"
#include "interface.h"
#include "main.h"


/* Globals */
GtkWidget *mainWin;
graph_t *mainGraph;


void disable_unimplemented (void)
{
	GtkWidget *mbar, *wid;
	GtkItemFactory *ifact;
	int i;
	gchar *unimp[] = {
		"/Graph/Properties/Planarity",
		"/Graph/Statistics/Diameter",
		"/Graph/Statistics/Girth",

		"/Prefab/Tree (Tn)",
	};

	mbar = GTK_WIDGET (gtk_object_get_data (GTK_OBJECT (mainWin),
							"menubar"));
	ifact = gtk_item_factory_from_widget (mbar);

	/* gtk_type_describe_heritage (GTK_OBJECT_TYPE (ifact)); */
	for (i=0; i < (sizeof (unimp) / sizeof (unimp[0])); i++) {
		wid = gtk_item_factory_get_widget (ifact, unimp[i]);
		gtk_widget_set_sensitive (wid, FALSE);
	}
}

int main (int argc, char *argv[])
{
	GtkWidget *it;

	fprintf (stderr, "\n\tGraphThing " GT_VERSION
					"\t(c) 2001 David Symonds\n\n");

	gtk_init (&argc, &argv);

	mainGraph = graph_create ();
	mainWin = create_mainWin ();
	disable_unimplemented ();
	gtk_widget_show (mainWin);

	status_push ("Ready.", 1);
	status_push ("Welcome to GraphThing!", 2);
	gtk_timeout_add (3000, (GtkFunction) status_pop, (gpointer *) 2);

	graph_init (mainWin);

	/* Configure some menu items */
	it = gtk_object_get_data (GTK_OBJECT (mainWin), "view-labels");
	gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (it), TRUE);
	it = gtk_object_get_data (GTK_OBJECT (mainWin), "view-weights");
	gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (it), FALSE);

	gtk_main ();

	graph_destroy (mainGraph);
	graph_close ();
	gtk_exit (0);

	return 0;	/* never reached, but needed to shut gcc up */
}
