/*
	math.c
*/

#include "math.h"


int math_factorial (int n)
{
	static int cache[] = {
		1, 1, 2, 6, 24, 120,		/* 0 - 5 */
		720, 5040, 40320, 362880, 3628800	/* 6 - 10 */
	};
	int i, tot;

	if (n < 2)
		return 1;
	else if (n <= 10)
		return cache[n];

	for (i=11, tot=cache[10]; i <= n; i++)
		tot *= i;

	return tot;
}

int math_choose (int n, int m)
{
	if ((m < 0) || (m > n))
		return 0;

	return (math_factorial (n) /
		(math_factorial (m) * math_factorial (n - m)));
}
