/*
	op.h
*/

#ifndef __OP_H__
#define __OP_H__

#include <glib.h>
#include "graph.h"
#include "matrix.h"


/*
 * FUNCTIONS
 */

/* Find menu */
void op_shortest_path (graph_t *g);

/* Properties menu */
void op_connected (graph_t *g);
void op_eulerian (graph_t *g);
void op_hamiltonian (graph_t *g);
void op_planar (graph_t *g);

/* Statistics menu */
void op_adj_matrix (graph_t *g);
void op_degree_sequence (graph_t *g);
void op_diameter (graph_t *g);
void op_girth (graph_t *g);
void op_chromatic_number (graph_t *g);
void op_chromatic_poly (graph_t *g);

/* Miscellaneous */
gint op_compare (gpointer a, gpointer b);
gboolean op_is_connected (graph_t *g);
matrix_t *op_get_adj_matrix (graph_t *g);
poly_t *op_calc_poly (graph_t *g);

#endif	/* __OP_H__ */
